# coding=utf8

# Copyright 2018 JDCLOUD.COM
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# NOTE: This class is auto generated by the jdcloud code generator program.

from jdcloud_sdk.core.jdcloudrequest import JDCloudRequest


class CreateLiveDomainRequest(JDCloudRequest):
    """
    创建直播域名V2
    """

    def __init__(self, parameters, header=None, version="v1"):
        super(CreateLiveDomainRequest, self).__init__(
            '/liveDomain', 'POST', header, version)
        self.parameters = parameters


class CreateLiveDomainParameters(object):

    def __init__(self, ):
        """
        """

        self.playDomain = None
        self.publishDomain = None
        self.sourceType = None
        self.backHttpType = None
        self.defaultSourceHost = None
        self.siteType = None
        self.backSourceType = None
        self.playProtocol = None
        self.forwardCustomVhost = None
        self.ipSource = None
        self.domainSource = None
        self.videoType = None
        self.audioType = None

    def setPlayDomain(self, playDomain):
        """
        :param playDomain: (Optional) 播放域名（仅siteType=1且publishDomain不为空时可为空）
        """
        self.playDomain = playDomain

    def setPublishDomain(self, publishDomain):
        """
        :param publishDomain: (Optional) 推流域名（siteType=push时playDomain与publishDomain不能同时传入）
        """
        self.publishDomain = publishDomain

    def setSourceType(self, sourceType):
        """
        :param sourceType: (Optional) 回源类型只能是[ips,domain]中的一种
        """
        self.sourceType = sourceType

    def setBackHttpType(self, backHttpType):
        """
        :param backHttpType: (Optional) 
        """
        self.backHttpType = backHttpType

    def setDefaultSourceHost(self, defaultSourceHost):
        """
        :param defaultSourceHost: (Optional) 默认回源host
        """
        self.defaultSourceHost = defaultSourceHost

    def setSiteType(self, siteType):
        """
        :param siteType: (Optional) 站点类型1:push(推流模式),2:pull(拉流模式),3:mix(混合模式)
        """
        self.siteType = siteType

    def setBackSourceType(self, backSourceType):
        """
        :param backSourceType: (Optional) 回源类型，支持rtmp, http-flv, https-flv, http-hls,https-hls，默认rtmp
        """
        self.backSourceType = backSourceType

    def setPlayProtocol(self, playProtocol):
        """
        :param playProtocol: (Optional) 播放协议，默认为rtmp,hdl,hls全选
        """
        self.playProtocol = playProtocol

    def setForwardCustomVhost(self, forwardCustomVhost):
        """
        :param forwardCustomVhost: (Optional) 转推地址
        """
        self.forwardCustomVhost = forwardCustomVhost

    def setIpSource(self, ipSource):
        """
        :param ipSource: (Optional) 回源IP信息
        """
        self.ipSource = ipSource

    def setDomainSource(self, domainSource):
        """
        :param domainSource: (Optional) 回源域名信息
        """
        self.domainSource = domainSource

    def setVideoType(self, videoType):
        """
        :param videoType: (Optional) 默认为H.264
        """
        self.videoType = videoType

    def setAudioType(self, audioType):
        """
        :param audioType: (Optional) 默认为AAC
        """
        self.audioType = audioType

